/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Controlador de la capa de lgica.
*/

#include "ControladorNegocio.h"

ControladorNegocio* ControladorNegocio::controlador = 0;

ControladorNegocio::ControladorNegocio(void)
{
	g=new Gestor();
}

ControladorNegocio::~ControladorNegocio(void)
{
}

void ControladorNegocio::setAlgAnalisis(bool gal, bool ven, bool mov, bool rad){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	opciones->setAlgAnalisis(gal, ven, mov, rad);
}

void ControladorNegocio::setAlgProc(bool gal, bool ven, bool mov, bool rad){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	opciones->setAlgProc(gal, ven, mov, rad);
}

bool* ControladorNegocio::getAlgAnalisis(){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	return opciones->getAlgAnalisis();
}

bool* ControladorNegocio::getAlgProc(){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	return opciones->getAlgProc();
}


void ControladorNegocio::setOpcionesPorDefecto(){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	opciones->setOpcionesPorDefecto();
}

void ControladorNegocio::setTamImagen(CvSize tam){
	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	opciones->setTamImagen(tam);
}

IplImage* ControladorNegocio::execute(IplImage* img, int num){
	return g->execute(img, num);
}
void ControladorNegocio::stop(){
	g->stop();
}
void ControladorNegocio::reset(){
	g->reset();
}

void ControladorNegocio::setMostrarEsqueleto(bool esqueleto){
	g->setMostrarEsqueleto(esqueleto);
}
void ControladorNegocio::setMostrarMascara(bool mascara){
	g->setMostrarMascara(mascara);
}

ControladorNegocio* ControladorNegocio::getControladorNegocio(){
	if(controlador == 0){
		controlador = new ControladorNegocio();
	}
	return controlador;
}

IplImage* ControladorNegocio::getImage(IplImage* frame){
	return g->getImage(frame);
}
