/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Modela las caractersticas que queremos de un esqueleto
*/
#pragma once
#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>
#include <iostream>

using namespace std;

class Esqueleto
{
public:
	Esqueleto(void);
	~Esqueleto(void);

	void setCabeza(CvRect);
	CvRect getCabeza();
	void setCuello(vector<CvPoint>);
	vector<CvPoint> getCuello();
	void setClavicula(vector<CvPoint>);
	vector<CvPoint> getClavicula();
	void setTronco(vector<CvPoint>);
	vector<CvPoint> getTronco();
	void setBrazo1(vector<CvPoint>);
	vector<CvPoint> getBrazo1();
	void setBrazo2(vector<CvPoint>);
	vector<CvPoint> getBrazo2();
	void setCadera(vector<CvPoint>);
	vector<CvPoint> getCadera();
	void setPierna1(vector<CvPoint>);
	vector<CvPoint> getPierna1();
	void setPierna2(vector<CvPoint>);
	vector<CvPoint> getPierna2();
	
	vector<CvPoint> getPuntos();//para el flujo optico
	void setPuntos(vector<CvPoint>);//para el flujo optico
	int getPosicion();
	//void setPosicion(int);

private:
	CvRect cabeza;
	vector<CvPoint> cuello;
	vector<CvPoint> clavicula;
	vector<CvPoint> tronco;
	vector<CvPoint> brazo1;
	vector<CvPoint> antebrazo1;
	vector<CvPoint> brazo2;
	vector<CvPoint> antebrazo2;
	vector<CvPoint> cadera;
	vector<CvPoint> pierna1;
	vector<CvPoint> pierna2;

	int posicion;
public:
	int actualizado;//0 si est actualizado, en caso contraio no est actualizado
};