/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Genera una mscara siendo de color negro la silueta de la persona y blanco el fondo
		Puede haber ruido en la mscara
*/
#pragma once
#include "Algoritmo.h"
#include "OpcionesNegocio.h"

#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>
#include <iostream>

using namespace std;

class FBorde:
	public Algoritmo
{
public:
	FBorde(void);
	~FBorde(void);

public:
	IplImage* execute(IplImage*, int);
	void finish();

private:
	void generarHistograma( IplImage *imgGray, CvHistogram  *hist, IplImage *hist_image, vector<int> &v );
	CvScalar hsv2rgb( float hue );

private:
	IplImage* image;
	string nombreRuta;
	int edge_thresh;
	int edge_thresh2;
	int aperture_sobel;
	int hdims, hist_size;
	IplImage *cedge, *gray, *edge;
	IplImage *hsv , *hue, *sat, *value, *hist_image;
	CvHistogram *hist;
	vector <int> vMax;
	double contadorColorVerde, maxVerde;
};
