/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Abstrae la busqueda y hallazgo de esqueletos
*/
#include "HistoricoEsqueletos.h"

HistoricoEsqueletos* HistoricoEsqueletos::historicoEsqueletos = 0;

HistoricoEsqueletos::HistoricoEsqueletos(void)
{
}
HistoricoEsqueletos* HistoricoEsqueletos::getHistoricoEsqueletos(){
	if(historicoEsqueletos == 0){
		historicoEsqueletos = new HistoricoEsqueletos();
	}
	return historicoEsqueletos;
}

void HistoricoEsqueletos::push_back(Esqueleto esqueletoIn){
	evolucionEsqueleto.push_back(esqueletoIn);
}
void HistoricoEsqueletos::erase(int i){
	evolucionEsqueleto.erase(evolucionEsqueleto.begin()+i);
}
void HistoricoEsqueletos::clear(){
	evolucionEsqueleto.clear();
}
Esqueleto HistoricoEsqueletos::element(int i){
	return evolucionEsqueleto[i];
}
Esqueleto HistoricoEsqueletos::back(){
	return evolucionEsqueleto.back();
}

int HistoricoEsqueletos::size(){
	return evolucionEsqueleto.size();
}