/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Abstrae la busqueda y hallazgo de esqueletos
*/
#pragma once
#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>
#include <iostream>

#include "Esqueleto.h"

using namespace std;

class HistoricoEsqueletos
{
public:
	static HistoricoEsqueletos* getHistoricoEsqueletos();

protected:
	HistoricoEsqueletos();
private:
	static HistoricoEsqueletos* historicoEsqueletos;
	vector<Esqueleto> evolucionEsqueleto;//lista con la secuencia de como ha evolucionado el esqueleto
public:
	void push_back(Esqueleto);
	void erase(int);
	void clear();
	Esqueleto element(int);
	Esqueleto back();
	int size();
};