/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Obsoleto
*/
#include "OpcionesNegocio.h"

OpcionesNegocio* OpcionesNegocio::opciones = 0;

OpcionesNegocio::OpcionesNegocio(void){
	nombreAlgProc.push_back("SegmentadorVideo");
	nombreAlgAna.push_back("AnalizadorShots");
	
	totalNombreAlg.push_back("FlujoOptico");
	totalNombreAlg.push_back("SegmentadorVideo");
	totalNombreAlg.push_back("AnalizadorShots");
	totalNombreAlg.push_back("DetectorMovimiento");
	totalNombreAlg.push_back("DetectorGalera");
	totalNombreAlg.push_back("DetectorVentanales");
	totalNombreAlg.push_back("DetectorRadiometrico");
	totalNombreAlg.push_back("DetectorMadera");

	velocidad=4;//lo normal son 4 para deteccion de shots para videos de 30fps//para el detector de movimiento mejor usar 1
	setOpcionesPorDefecto();
	stop = false;
	pause = false;
}

OpcionesNegocio::~OpcionesNegocio(void)
{
}

string OpcionesNegocio::getDirectorioSalida(){
	return directorioSalida;
}

string OpcionesNegocio::getDirectorioEntrada(){
	return directorioEntrada;
}

bool OpcionesNegocio::getCopiarVideo(){
	return copiarVideo;
}

CvSize OpcionesNegocio::getTamImagen(){
	return tamImagen;
}

bool* OpcionesNegocio::getAlgAnalisis(){
	bool* vec = (bool*)cvAlloc(4*sizeof(bool));
	vec[0] = galeraAnalisis;
	vec[1] = ventanalesAnalisis;
	vec[2] = movimientoAnalisis;
	vec[3] = radiometricoAnalisis;
	return vec;
}

bool* OpcionesNegocio::getAlgProc(){
	bool* vec = (bool*)cvAlloc(4*sizeof(bool));
	vec[0] = galeraProc;
	vec[1] = ventanalesProc;
	vec[2] = movimientoProc;
	vec[3] = radiometricoProc;
	return vec;
}

bool OpcionesNegocio::getGenerarAVI(){
	return generarAVI;
}

bool OpcionesNegocio::getStop(){
	return stop;
}

bool OpcionesNegocio::getPause(){
	return pause;
}

void OpcionesNegocio::setDirectorioSalida(string cadena){
	directorioSalida = cadena;
}

void OpcionesNegocio::setDirectorioEntrada(string filename){
	directorioEntrada = filename;
}

void OpcionesNegocio::setCopiarVideo(bool flag){
	copiarVideo = flag;
}

void OpcionesNegocio::setTamImagen(CvSize tam){
	tamImagen = tam;
}

void OpcionesNegocio::setAlgAnalisis(bool gal, bool ven, bool mov, bool rad){
	galeraAnalisis = gal;
	ventanalesAnalisis = ven;
	movimientoAnalisis = mov;
	radiometricoAnalisis = rad;
	nombreAlgAna.clear();
	nombreAlgAna.push_back("AnalizadorShots");
	if(gal){
		nombreAlgAna.push_back("DetectorGalera");
	}
	if(ven){
		nombreAlgAna.push_back("DetectorVentanales");
	}
	if(mov){
		nombreAlgAna.push_back("DetectorMovimiento");
	}
	if(rad){
		nombreAlgAna.push_back("DetectorRadiometrico");
	}
}

void OpcionesNegocio::setAlgProc(bool gal, bool ven, bool mov, bool rad){
	galeraProc = gal;
	ventanalesProc = ven;
	movimientoProc = mov;
	radiometricoProc = rad;
	nombreAlgProc.clear();
	nombreAlgProc.push_back("SegmentadorVideo");
	if(gal){
		nombreAlgProc.push_back("DetectorGalera");
	}
	if(ven){
		nombreAlgProc.push_back("DetectorVentanales");
	}
	if(mov){
		nombreAlgProc.push_back("DetectorMovimiento");
	}
	if(rad){
		nombreAlgProc.push_back("DetectorRadiometrico");
	}
}

void OpcionesNegocio::setGenerarAVI(bool flag){
	generarAVI = flag;
}

void OpcionesNegocio::setStop(bool flag){
	stop = flag;
}

void OpcionesNegocio::setPause(bool flag){
	pause = flag;
}

void OpcionesNegocio::setOpcionesPorDefecto(){
	QString aux = _getcwd(NULL,0);
	aux.replace(0,1,aux.at(0).toUpper());
	directorioSalida = aux.toStdString();
	umbralPuntosFuera = 60;
	umbralFrames = 170;
	MAX_COUNT = 200;
	anchoComparacionFrames = 4;
	copiarVideo = false;
	tamSB = 1;
	porcentajeMinimoPuntos = 12;
	dist_min = 50;
	margenBordes = 30;
	tamBloqueGiro = 4;
	umbralInicioGiro = 5.0;
	umbralFinGiro = 1;
	tamImagen.height = 480;
	tamImagen.width = 640;
	galeraProc = false;
	galeraAnalisis = false;
	ventanalesProc = false;
	ventanalesAnalisis = false;
	movimientoProc = false;
	movimientoAnalisis = false;
	radiometricoProc = false;
	radiometricoAnalisis = false;
	nombreAlgProc.clear();
	nombreAlgAna.clear();
	nombreAlgProc.push_back("SegmentadorVideo");
	nombreAlgAna.push_back("AnalizadorShots");
	generarSB = false;
	generarAVI = false;
	maxXRel = 6.0;
	maxYRel = 8.6;
	pendienteX = 1.5;
	puntoInicioX = 3.4;
	pendienteY = 6.0;
	puntoInicioY = 6.0;
}

OpcionesNegocio* OpcionesNegocio::getOpcionesNegocio(){
	if(opciones == 0){
		opciones = new OpcionesNegocio();
	}
	return opciones;
}

