/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Obsoleto
*/
#include <QString>
#include "cv.h"
#include <direct.h>

#pragma once

using namespace std;


const double umbralDesplazamiento = 150.000;//umbral de desplazamiento medio de los puntos a partir del cual se considera que se ha producido un shot.VO=200.000



const unsigned int nElementosBorrarCP = 200;//constante de elementos que se quieren borrar de un solo golpe de contador puntos


const int proporcionFramesProc = 10;//determina cada cuantos frames procesamos uno de ellos: 1/4, 1/5, etc


class OpcionesNegocio
{
public:
	~OpcionesNegocio(void);

public:
	static OpcionesNegocio* getOpcionesNegocio();

protected:
	OpcionesNegocio();

private:
	static OpcionesNegocio* opciones;
	string directorioSalida;
	string directorioEntrada;
	int umbralPuntosFuera;//umbral de puntos que pueden desaparecer en una subsucesion de frames
	unsigned int anchoComparacionFrames;
	bool copiarVideo;
	int tamSB;
	int MAX_COUNT;
	int porcentajeMinimoPuntos;//define el numero minimo de puntos de seguimiento permitidos dentro de una imagen. Si la constante vale 5, significa que como mnimo deber haber el 5% del maximo de puntos permitidos.VO=5
	int umbralFrames;
	int dist_min;
	int margenBordes;//grosor del borde de la imagen que no se considera
	int tamBloqueGiro;//numero de frames procesados que forman parte del delta(intervalo) sobre el que se calcula la derivada
	double umbralInicioGiro;//valor umbral de la derivada que consideramos inicio de giro
	int umbralFinGiro;//valor umbral de la derivada que consideramos fin de giro
	CvSize tamImagen;
	bool galeraProc;
	bool galeraAnalisis;
	bool ventanalesProc;
	bool ventanalesAnalisis;
	bool movimientoProc;
	bool movimientoAnalisis;
	bool radiometricoProc;
	bool radiometricoAnalisis;
	bool generarSB;
	bool generarAVI;
	double maxXRel;
	double maxYRel;
	double pendienteX;
	double puntoInicioX;
	double pendienteY;
	double puntoInicioY;

	//estos son los identificadores de los nombres de los algoritmos
	vector<string> nombreAlgProc;
	vector<string> nombreAlgAna;
	vector<string> totalNombreAlg;

	bool stop;
	bool pause;

public:
	int velocidad;

public:
	bool getGenerarAVI();
	vector<string> getNombreAlgProc(){return nombreAlgProc;}
	vector<string> getNombreAlgAna(){return nombreAlgAna;}
	vector<string> getTotalNombreAlg(){return totalNombreAlg;}
	string getDirectorioSalida();
	string getDirectorioEntrada();
	bool getCopiarVideo();
	CvSize getTamImagen();
	bool* getAlgAnalisis();
	bool* getAlgProc();
	bool getStop();
	bool getPause();
	void setDirectorioSalida(string);
	void setDirectorioEntrada(string);
	void setCopiarVideo(bool);
	void setTamImagen(CvSize);
	void setAlgAnalisis(bool, bool, bool, bool);
	void setAlgProc(bool, bool, bool, bool);
	void setGenerarSB(bool);
	void setGenerarAVI(bool);
	void setStop(bool);
	void setPause(bool);

public:
	void setOpcionesPorDefecto();

};
