/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Controlador de la capa de lgica.
*/
#include "OpcionesNegocio.h"
#include "Gestor.h"
#include <QString>
#include <vector>
#include "cv.h"
#include "highgui.h"


#pragma once

class ControladorNegocio
{
public:
	~ControladorNegocio(void);

protected:
	ControladorNegocio();

public:
	static ControladorNegocio* getControladorNegocio();

public:
	
	IplImage* execute(IplImage*, int);
	IplImage* getImage(IplImage *);
	void reset();
	void stop();
	void setMostrarEsqueleto(bool esqueleto);
	void setMostrarMascara(bool mascara);
	

public:
	vector<string> getTotalNombreAlg();
	bool* getAlgAnalisis();
	bool* getAlgProc();

	void setTamImagen(CvSize);
	void setOpcionesPorDefecto();
	void setAlgAnalisis(bool, bool, bool, bool);
	void setAlgProc(bool, bool, bool, bool);


private:
	static ControladorNegocio* controlador;
	Gestor * g;

};
