/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Funciones matemticas bsicas de caracter general
*/

#include "Utilidades.h"


int& max (int a, int b) {
	if (a >= b) return a;
	return b;
}

int& max (vector<int> a) {
	int i;
	int b=0;
	if(a.size()>0){
		b= a[0];
		for(i=0;i<a.size();i++){
			if (a[i] > b){
				b=a[i];
			}
		}
	}
	return b;
}

int& min (int a, int b) {
	if (a <= b) return a;
	return b;
}

int& min (vector<int> a) {
	int i;
	int b=0;
	if(a.size()>0){
		b= a[0];
		for(i=0;i<a.size();i++){
			if (a[i] < b){
				b=a[i];
			}
		}
	}
	return b;
}

vector<ParPD> filtrarEr(vector<int> datos, double coeficiente, double coeficiente2, double coeficiente3, vector<ParPD> erIn){
	int i=0,j=0, valor, valorPrev1, valorPrev2, valorPrev3;
	vector<int> val;
	for(i=0;i<4;i++){
		val.push_back(0);//inicializacion
	}
	vector<ParPD> er=erIn;
	i=2;
	while(i<er.size()){//eliminamos aquellos que sean poco significativos
		valor=datos[er[i].posicion];
		valorPrev1=datos[er[i-1].posicion];

		if(abs(valor-valorPrev1)<abs(coeficiente)){
			
			er.erase(er.begin()+i);
			if(i<er.size()){
				valorPrev2=datos[er[i].posicion];
				if((valor<valorPrev1 && valorPrev1<valorPrev2)|| (valor>valorPrev1 && valorPrev1>valorPrev2)){
					er.erase(er.begin()+i-1);
				}else{
					er.erase(er.begin()+i);
				}
			}
			
			i--;

		}
		i++;
	}
	//tratamos el primer elemento aparte
	if(er.size()>1){
		valor=datos[er[1].posicion];
		valorPrev1=datos[er[0].posicion];
		if(abs(valor-valorPrev1)<abs(coeficiente)){
			er.erase(er.begin()+0);
		}
	}
	for(i=1;i<er.size()-1;i++){
		if(abs(er[i-1].posicion - er[i+1].posicion)<coeficiente2){
			er.erase(er.begin()+i);
			valor=datos[er[i].posicion];
			valorPrev1=datos[er[i-1].posicion];
			if(i<er.size()){
				valorPrev2=datos[er[i].posicion];
				if((valor<valorPrev1 && valorPrev1<valorPrev2)|| (valor>valorPrev1 && valorPrev1>valorPrev2)){
					er.erase(er.begin()+i-1);
				}else{
					er.erase(er.begin()+i);
				}
			}
			i--;
		}
	}
	for(i=1;i<er.size();i++){//comparacion entre maximo y minimo o minimo y maximo
		if(abs(er[i-1].posicion - er[i].posicion)<coeficiente3){
			int banderaEsMinimo=0;
			if(datos[er[i-1].posicion] < datos[er[i].posicion]){
				banderaEsMinimo=1;
			}
			er.erase(er.begin()+i-1);
			i--;//aqui????
			
			if(i>0){
				valor=datos[er[i].posicion];
				valorPrev1=datos[er[i-1].posicion];

				if((valor>valorPrev1 && banderaEsMinimo!=0) || (valor<valorPrev1 && banderaEsMinimo==0)){//si los datos son maximos relativos y valor es el mayor o si son minimos relativos y valor es el menor
					er.erase(er.begin()+i-1);
				}else{
					er.erase(er.begin()+i);
				}
			}
			
		}
	}
	return  er;
}
ExtremosRelativos calcularExtremosRelativos(vector<CvPoint> datos, double coeficiente, double coeficiente2, double coeficiente3, int varDependiente){
	int i;
	vector<int> datosTransformados;
	
	if(varDependiente==0){
		for(i=0;i<datos.size();i++){
			datosTransformados.push_back(datos[i].y);
		}
	}else{
		for(i=0;i<datos.size();i++){
			datosTransformados.push_back(datos[i].x);
		}
	}

	return calcularExtremosRelativos(datosTransformados, coeficiente, coeficiente2, coeficiente3);
}


ExtremosRelativos calcularExtremosRelativos(vector<int> datos, double coeficiente, double coeficiente2, double coeficiente3){
	ExtremosRelativos er;
/**/	ExtremosRelativos erAux;
	int i,j;
	int valor, valorPrev;
	
	valor=datos[1];
	valorPrev=datos[0];

	vector<ParPD> derivada, extremosRel, extremosRelAux;//extremosRel son todos los extremos relativos
	ParPD parInicio;
	parInicio.derivada=valor - valorPrev;
	parInicio.posicion=1;
	derivada.push_back(parInicio);
	int subeMucho=0, bajaMucho=0;
	//er.maxRel.push_back(0);
	//er.minRel.push_back(0);

	//if((valorPrev-min.y) < 0.33*(max.y - min.y)){//el brazo de la izquierda de la imagen est bastante levantado
	//er.maxRel.push_back(0);
	//}

	if(datos.size()>2){
		int bandera=0;//para saber si el ultimo elemento era un minimo o un maximo
		int banderaHeMetidoDato=0;//para saber si ya he metido un dato en esta iteracion, para evitar meterlo dos veces
		for(i=2;i<datos.size();i++){// calculamos los valores de la derivada
			banderaHeMetidoDato=0;
			valorPrev=valor;
			valor = datos[i];
			ParPD par;
			par.derivada=valor - valorPrev;
			par.posicion=i;
			derivada.push_back(par);
		}//fin for

		extremosRel=derivada;//hacemos una copia
		for(i=0;i<extremosRel.size();i++){//eliminamos los puntos en los que la derivada es 0
			if(extremosRel[i].derivada==0){
				extremosRel.erase(extremosRel.begin()+i);
				i--;
			}
		}
		int banderaCrecimiento=0;//0 si no hay ni crecimiento ni decrecimiento, 1 si hay crecimiento y -1 si hay decrecimiento
		if(extremosRel.size()==0){//si no hay extremos relativos, dar una solucion por defecto
			er.minRel.push_back(0);
			er.maxRel.push_back(datos.size()-1);
			return er;
		}
		ParPD parAux=extremosRel[0];
		if(extremosRel[0].derivada>0){
			banderaCrecimiento=1;
		}else{
			banderaCrecimiento=-1;
		}
		for(i=1;i<extremosRel.size();i++){//eliminamos subsecuencias de - o de +, para as quedarnos con los autenticos extremos relativos
			if(extremosRel[i].derivada>0 && banderaCrecimiento<1){//si es el primer elemento>0 de una subsecuencia de ello
				extremosRel.insert(extremosRel.begin()+i,parAux);
				i++;
				banderaCrecimiento=1;
			}else if(extremosRel[i].derivada<0 && banderaCrecimiento>(-1)){//si es el primer elemento<0 de una subsecuencia de ello
				extremosRel.insert(extremosRel.begin()+i,parAux);
				i++;
				banderaCrecimiento=-1;
			}
			parAux=extremosRel[i];
			extremosRel.erase(extremosRel.begin()+i);
			i--;
		}
		extremosRel.push_back(parAux);

		//separamos los maximos y minimos relativos en dos, dentro de er
		//if(extremosRel[1].derivada>0){//para el primer elemento
		//	er.maxRel.push_back(extremosRel[0].posicion);
		//}else{
		//	er.minRel.push_back(extremosRel[0].posicion);
		//}
		//for(i=1;i<extremosRel.size();i++){//para los demas elementos
		//	if(extremosRel[i].derivada>0){
		//		er.minRel.push_back(extremosRel[i].posicion);
		//	}else{
		//		er.maxRel.push_back(extremosRel[i].posicion);
		//	}
		//}

		//erAux.maxRel = er.maxRel;
		//erAux.minRel = er.minRel;
		if(extremosRel[1].derivada>0){
			extremosRel[0].derivada=-1;
		}else{
			extremosRel[0].derivada=1;
		}
		if(extremosRel[0].posicion>1){
				extremosRel[0].posicion--;
			}
		extremosRelAux=extremosRel;
		extremosRel = filtrarEr(datos, coeficiente, coeficiente2, coeficiente3, extremosRel);
		int contador=2;
		if(extremosRelAux.size()>2){
			int coeficiente1Aux=coeficiente;
			while(extremosRel.size()<2){
				if(contador>4){
					extremosRel=extremosRelAux;
					break;
				}
				coeficiente1Aux=0.85*coeficiente1Aux;
				extremosRel = filtrarEr(datos, coeficiente1Aux, coeficiente2, coeficiente3, extremosRelAux);
				contador++;
				if(extremosRel.size()>1){
					break;
				}
			}
			
		}
		//convertimos los datos
		if(extremosRel.size()>1){
			if(extremosRel[1].derivada>0){//para el primer elemento
				er.maxRel.push_back(extremosRel[0].posicion);
			}else{
				er.minRel.push_back(extremosRel[0].posicion);
			}
		}
		for(i=1;i<extremosRel.size();i++){//para los demas elementos
			if(extremosRel[i].derivada>0){
				er.minRel.push_back(extremosRel[i].posicion);
			}else{
				er.maxRel.push_back(extremosRel[i].posicion);
			}
		}
	}//fin if datos > 2


	return er;
}



// comparar enteros
int comparar(const void *e1, const void *e2){
	tipoComparacion *elem1 = (tipoComparacion*) e1;
	tipoComparacion *elem2 = (tipoComparacion*) e2;

	if ( elem1->valor < elem2->valor)
      return -1;
   else if (elem1->valor > elem2->valor)
      return 1;
   else
      return 0;
}

vector<tipoComparacion> ordenarQsort(vector<tipoComparacion> input){
	int i;
	tipoComparacion datos[100];
	vector<tipoComparacion> salida;
	for(i=0;i<input.size();i++){
		datos[i]=input[i];
	}
	
	qsort((void *)&datos, input.size(), sizeof(tipoComparacion), comparar);
	
	for(i=0;i<input.size();i++){
		salida.push_back(datos[i]);
	}	
	return salida;
}
